#include "cdhgripper_rs485.h"
#include "def_param_motor.h"
#include "logic_local_def.h"
#include "callsystem.h"
#include "logic_eap.h"

#define CMD_WR_ADDR_INI       0x0100 //初始化夹爪
#define CMD_WR_ADDR_FORCE     0x0101 //夹爪力值
#define CMD_WR_ADDR_POS       0x0103 //夹爪力位置
#define CMD_WR_ADDR_SPEED     0x0104 //夹爪力速度
#define CMD_WR_ADDR_PROTECD   0x0300 //写保护
#define CMD_WR_ADDR_INIDIRECT 0x0301 //初始化方向
#define CMD_RD_ADDR_INI       0x0200 //初始化反馈
#define CMD_RD_ADDR_STATUS    0x0201 //夹持状态反馈
#define CMD_RD_ADDR_POS       0x0202 //夹爪力位置反馈
#define CMD_RD_ADDR_FORCE     0x0101 //夹爪力值反馈
#define CMD_RD_ADDR_SPEED     0x0104 //夹爪力速度反馈
#define COMM_LEN              64

CDHGripperRS485::CDHGripperRS485(const QString& name, int32_t id) :CDriverCard(name, id)
{
    m_pSerialPort = new CMSerialPort(QString("COMPORT"), 0);
    m_Variants.add_Variant(Var_Motor_Pos_ID,
                           QObject::tr("Pos"), int(0), false,
                           Variant::TONONE, QStringList() << "0" << "1000");
    m_Variants.add_Variant(Var_Motor_Default_speed_ID,
                           QObject::tr("Default_Speed"), int(1), false,
                           Variant::TOXML, QStringList() << "1" << "100");
    m_Variants.add_Variant(Var_Motor_Pas_softlimit_ID,
                           QObject::tr("Nag_Pos_Thres"), int(0), false,
                           Variant::TOXML, QStringList() << "0" << "1000");
    m_Variants.add_Variant(Var_Motor_Nag_softlimit_ID,
                           QObject::tr("Pas_Pos_Thres"), int(0), false,
                           Variant::TOXML, QStringList() << "0" << "1000");

    m_Variants.add_Variant(Var_Motor_Home_orginaloffset_ID,
                           QObject::tr("HomeOffset"), int(0), false,
                           Variant::TOXML, QStringList() << "0" << "1000");

    //HACK: No use
    m_Variants.add_Variant(Var_Motor_Hashome_ID,
                           QObject::tr("HasHomed"), bool(false), false,
                           Variant::TONONE, QStringList() << "0" << "1");
    m_Variants.add_Variant(Var_Gripper_Home_Direct,
                           QObject::tr("Home_Direct"), uint(1), false,
                           Variant::TONONE, QStringList() << "Negative" << "Passitive");

    m_Variants.add_Variant(Var_Gripper_Home_State,
                           QObject::tr("Home_State"), uint(0), false,
                           Variant::TONONE, QStringList() << "Uinitialize" << "Initialized" << "Initializing");

}

CDHGripperRS485::~CDHGripperRS485(void)
{
    exit_driver();

    if(nullptr != m_pSerialPort) {
        delete m_pSerialPort;
        m_pSerialPort = nullptr;
    }
}

int32_t CDHGripperRS485::init_driver()
{
    if(_Sys_Instance_.IsSimulator()) {
        return RTN_SUCCESS1;
    }

    int ret = 0;
    try {
        ret = m_pSerialPort->open();

        ret = Init(0xA5);           //初始化
        if(!ret)
            return false;

        Sleep(200);
        ret = SetForceValue(20);  //设置力度
        if(!ret)
            return false;

        Sleep(200);
        ret = SetSpeedValue(50);  //设置速度
        if(!ret)
            return false;
        Sleep(200);
        ret = SetInitDirect(0x01);  //设置初始化方向
        if(!ret) return false;
        //Sleep(200);
        //ret = SetWriteProtecd(0x01);//设置写保护
        //if(!ret)
        //    return false;
        Sleep(200);
        ret = SetPosValue(500);    //设置位置
        if(!ret)
            return false;
    } catch(QString ex) {
        throw(QString("%1 %2").arg(m_sName).arg(ex));
    }

    return ret;
}

int32_t CDHGripperRS485::exit_driver()
{
    if(nullptr != m_pSerialPort) {
        m_pSerialPort->close();
    }
    return RTN_SUCCESS1;
}

unsigned char xorOperation8(unsigned char n1, unsigned char n2)
{
    unsigned char result = 0;
    for(int i = 0; i < 8; i++) {
        if(((n1 >> i) & 1) != ((n2 >> i) & 1))
            result |= (1 << i);
    }
    return result;
}

unsigned short xorOperation16(short n1, short n2)
{
    unsigned short result = 0;
    for(int i = 0; i < 16; i++) {
        if(((n1 >> i) & 1) != ((n2 >> i) & 1))
            result |= (1 << i);
    }
    return result;
}

unsigned char CDHGripperRS485::CheckSum(unsigned char* pStr, int nLen, bool bLow)
{
    unsigned short checksum = 0xffff;
    for(int i = 0; i < nLen; ++i) {
        unsigned char c = xorOperation8(pStr[i], checksum);
        checksum &= 0xff00;
        checksum |= c;
        for(int j = 0; j < 8; ++j) {
            checksum >>= 1;
            if(checksum & 0x01) {
                checksum = xorOperation16(checksum, 0xa001);
            }
        }

    }

    if(bLow) {
        return checksum & 0x00ff;
    } else {
        return (checksum & 0xff00) >> 8;
    }
}

unsigned short CDHGripperRS485::CRC16(byte* pDataIn, int iLenIn)
{
    byte buf;
    unsigned short crc16 = 0xFFFF;
    static const unsigned short crc16Table[] =
    {
        0x0000, 0xC0C1, 0xC181, 0x0140, 0xC301, 0x03C0, 0x0280, 0xC241,
        0xC601, 0x06C0, 0x0780, 0xC741, 0x0500, 0xC5C1, 0xC481, 0x0440,
        0xCC01, 0x0CC0, 0x0D80, 0xCD41, 0x0F00, 0xCFC1, 0xCE81, 0x0E40,
        0x0A00, 0xCAC1, 0xCB81, 0x0B40, 0xC901, 0x09C0, 0x0880, 0xC841,
        0xD801, 0x18C0, 0x1980, 0xD941, 0x1B00, 0xDBC1, 0xDA81, 0x1A40,
        0x1E00, 0xDEC1, 0xDF81, 0x1F40, 0xDD01, 0x1DC0, 0x1C80, 0xDC41,
        0x1400, 0xD4C1, 0xD581, 0x1540, 0xD701, 0x17C0, 0x1680, 0xD641,
        0xD201, 0x12C0, 0x1380, 0xD341, 0x1100, 0xD1C1, 0xD081, 0x1040,
        0xF001, 0x30C0, 0x3180, 0xF141, 0x3300, 0xF3C1, 0xF281, 0x3240,
        0x3600, 0xF6C1, 0xF781, 0x3740, 0xF501, 0x35C0, 0x3480, 0xF441,
        0x3C00, 0xFCC1, 0xFD81, 0x3D40, 0xFF01, 0x3FC0, 0x3E80, 0xFE41,
        0xFA01, 0x3AC0, 0x3B80, 0xFB41, 0x3900, 0xF9C1, 0xF881, 0x3840,
        0x2800, 0xE8C1, 0xE981, 0x2940, 0xEB01, 0x2BC0, 0x2A80, 0xEA41,
        0xEE01, 0x2EC0, 0x2F80, 0xEF41, 0x2D00, 0xEDC1, 0xEC81, 0x2C40,
        0xE401, 0x24C0, 0x2580, 0xE541, 0x2700, 0xE7C1, 0xE681, 0x2640,
        0x2200, 0xE2C1, 0xE381, 0x2340, 0xE101, 0x21C0, 0x2080, 0xE041,
        0xA001, 0x60C0, 0x6180, 0xA141, 0x6300, 0xA3C1, 0xA281, 0x6240,
        0x6600, 0xA6C1, 0xA781, 0x6740, 0xA501, 0x65C0, 0x6480, 0xA441,
        0x6C00, 0xACC1, 0xAD81, 0x6D40, 0xAF01, 0x6FC0, 0x6E80, 0xAE41,
        0xAA01, 0x6AC0, 0x6B80, 0xAB41, 0x6900, 0xA9C1, 0xA881, 0x6840,
        0x7800, 0xB8C1, 0xB981, 0x7940, 0xBB01, 0x7BC0, 0x7A80, 0xBA41,
        0xBE01, 0x7EC0, 0x7F80, 0xBF41, 0x7D00, 0xBDC1, 0xBC81, 0x7C40,
        0xB401, 0x74C0, 0x7580, 0xB541, 0x7700, 0xB7C1, 0xB681, 0x7640,
        0x7200, 0xB2C1, 0xB381, 0x7340, 0xB101, 0x71C0, 0x7080, 0xB041,
        0x5000, 0x90C1, 0x9181, 0x5140, 0x9301, 0x53C0, 0x5280, 0x9241,
        0x9601, 0x56C0, 0x5780, 0x9741, 0x5500, 0x95C1, 0x9481, 0x5440,
        0x9C01, 0x5CC0, 0x5D80, 0x9D41, 0x5F00, 0x9FC1, 0x9E81, 0x5E40,
        0x5A00, 0x9AC1, 0x9B81, 0x5B40, 0x9901, 0x59C0, 0x5880, 0x9841,
        0x8801, 0x48C0, 0x4980, 0x8941, 0x4B00, 0x8BC1, 0x8A81, 0x4A40,
        0x4E00, 0x8EC1, 0x8F81, 0x4F40, 0x8D01, 0x4DC0, 0x4C80, 0x8C41,
        0x4400, 0x84C1, 0x8581, 0x4540, 0x8701, 0x47C0, 0x4680, 0x8641,
        0x8201, 0x42C0, 0x4380, 0x8341, 0x4100, 0x81C1, 0x8081, 0x4040
    };

    for(auto i = 0; i < iLenIn; ++i) {
        buf = pDataIn[i] ^ crc16;
        crc16 >>= 8;
        crc16 ^= crc16Table[buf];
    }
    return (crc16);
}

bool CDHGripperRS485::Init(int value)
{
    return SendCommData(CMD_WR_ADDR_INI, value);
}

bool CDHGripperRS485::SetForceValue(int value)
{
    return SendCommData(CMD_WR_ADDR_FORCE, value);
}

bool CDHGripperRS485::SetPosValue(int value)
{
    if(_Sys_Instance_.IsSimulator()) {
        m_Variants.get_VData(Var_Motor_Pos_ID)->setValue(value);
        return value;
    }

    if(true == SendCommData(CMD_WR_ADDR_POS, value)) {
        m_Variants.get_VData(Var_Motor_Pos_ID)->setValue(value);
        return true;
    } else {
        return false;
    }
}

bool CDHGripperRS485::GetPosValue(int& value)
{
    //TODO: fresh pos 
    value = m_Variants.get_VData(Var_Motor_Pos_ID)->toInt();

    return true;
}

bool CDHGripperRS485::SetSpeedValue(int value)
{
    if(_Sys_Instance_.IsSimulator()) {
        m_Variants.get_VData(Var_Motor_Default_speed_ID)->setValue(value);
        return true;
    }

    if(true == SendCommData(CMD_WR_ADDR_SPEED, value)) {
        m_Variants.get_VData(Var_Motor_Default_speed_ID)->setValue(value);
        return true;
    } else {
        return false;
    }
}

bool CDHGripperRS485::SetWriteProtecd(int value)
{
    return SendCommData(CMD_WR_ADDR_PROTECD, value);
}

bool CDHGripperRS485::SetInitDirect(int value)
{
    return SendCommData(CMD_WR_ADDR_INIDIRECT, value);
}

bool CDHGripperRS485::SendCommData(int addr, int value)
{
    unsigned char Buf[12] = { 0 };
    Buf[0] = 0x01;
    Buf[1] = 0x06;
    Buf[3] = addr & 0x00ff;
    Buf[2] = addr >> 8;
    Buf[4] = value >> 8;
    Buf[5] = value & 0x00ff;
    short c = CRC16(&Buf[0], 6);
    Buf[6] = c & 0x00ff;    //! 高低位交换
    Buf[7] = c >> 8;

    int iRet = m_pSerialPort->send((char*)Buf, 8);

    int32_t irtn = m_pSerialPort->wait();

    m_pSerialPort->receive((char*)Buf, irtn);
    if(irtn < 8) {
        return false;
    }

    unsigned char cLow = c & 0x00ff;
    unsigned char cHigh = c >> 8;
    if(Buf[0] == 0x01
       && Buf[1] == 0x06
       && Buf[3] == (addr & 0x00ff)
       && Buf[2] == (addr >> 8)
       && Buf[4] == (value >> 8)
       && Buf[5] == (value & 0x00ff)
       && cLow == Buf[6]
       && cHigh == Buf[7]) {
        return true;
    }

    return false;
}

int  CDHGripperRS485::ReceiveCommData(int addr)
{
    unsigned char Buf[8] = { 0 };
    Buf[0] = 0x01;
    Buf[1] = 0x03;
    *(short*)(&Buf[2]) = addr;
    Buf[4] = 0x00;
    Buf[5] = 0x01;
    short c = CRC16(&Buf[0], 6);
    Buf[6] = c & 0x00ff;
    Buf[7] = c >> 8;

    if(!m_pSerialPort->send((char*)Buf, 8)) {
        return -1;
    }
    int32_t irtn = m_pSerialPort->wait();

    int lenght = m_pSerialPort->receive((char*)Buf, irtn);
    if(lenght < 7) {
        return -1;
    }

    unsigned char cLow = c & 0x00ff;
    unsigned char cHigh = c >> 8;
    if(Buf[0] == 0x01
       && Buf[1] == 0x03
       && Buf[2] == 0x02
       && cLow == Buf[6]
       && cHigh == Buf[7]) {
        return *(short*)(&Buf[3]);
    }

    return -1;
}

int CDHGripperRS485::GetInitState()
{
    return ReceiveCommData(CMD_RD_ADDR_INI);
}

int CDHGripperRS485::GetGripperState()
{
    return ReceiveCommData(CMD_RD_ADDR_STATUS);
}

int CDHGripperRS485::GetPosState()
{
    return ReceiveCommData(CMD_RD_ADDR_POS);
}

int CDHGripperRS485::GetForceState()
{
    return ReceiveCommData(CMD_RD_ADDR_FORCE);
}

int CDHGripperRS485::GetSpeedState()
{
    return ReceiveCommData(CMD_RD_ADDR_SPEED);
}

int CDHGripperRS485::ReadConfig(QDomElement& root)
{
    int iIndex = CDriverCard::ReadConfig(root);

    QDomNodeList List = root.childNodes();
    //int iSizeList=List.size();

    iIndex = m_pSerialPort->ReadConfig(List.at(iIndex).toElement());

    return iIndex;
}

QDomElement CDHGripperRS485::WriteConfig(QDomDocument& doc, QDomElement& root)
{
    QDomElement element = CDriverCard::WriteConfig(doc, root);

    QDomElement ele1 = m_pSerialPort->WriteConfig(doc, element);

    //element.appendChild(ele1);

    return element;
}

void CDHGripperRS485::do_msg(int iID, QVariantList& vlInput, V_MsgOutput* pvlOutput)
{
    if(iID == MOVEPOS) {
        int iPos = vlInput[0].toInt();
        SetPosValue(iPos);
    } else if(iID == kFreshPos) {
        int iPos = 0;
        GetPosValue(iPos);
    } else if(iID == kSetSpeed) {
        int iSpeed = vlInput[0].toInt();
        SetSpeedValue(iSpeed);
    } else if(iID == kReset) {
        if(false == Init(0xA5)) {
            MQT_THROW_CODESTR(ALARM_EAP_RESERVED, QObject::tr("Init Gripper failed"));
        }
    }
}
